* [PATCH] guix lint: add the --checkers option.
@ 2014-10-12 2:19 Cyril Roelandt
2014-10-12 17:02 ` Ludovic Courtès
0 siblings, 1 reply; 4+ messages in thread
From: Cyril Roelandt @ 2014-10-12 2:19 UTC (permalink / raw)
To: guix-devel
* guix/scripts/lint.scm: add the "--checkers" option.
* doc/guix.texi: Update "Invoking guix lint".
* tests/guix-lint.sh: New file
* Makefile.am (SCM_TESTS): Add it.
---
Makefile.am | 3 +-
doc/guix.texi | 5 +++
guix/scripts/lint.scm | 122 +++++++++++++++++++++++++++++---------------------
tests/guix-lint.sh | 70 +++++++++++++++++++++++++++++
4 files changed, 149 insertions(+), 51 deletions(-)
create mode 100644 tests/guix-lint.sh
diff --git a/Makefile.am b/Makefile.am
index eba34af..34d2360 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -182,7 +182,8 @@ SH_TESTS = \
tests/guix-package.sh \
tests/guix-system.sh \
tests/guix-archive.sh \
- tests/guix-authenticate.sh
+ tests/guix-authenticate.sh \
+ tests/guix-lint.sh
if BUILD_DAEMON
diff --git a/doc/guix.texi b/doc/guix.texi
index 583bdbf..367972f 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -2781,6 +2781,11 @@ The @var{options} may be zero or more of the following:
@table @code
+@item --checkers
+@itemx -c
+Only enable the checkers specified in a comma-separated list using the
+names returned by --list-checkers.
+
@item --list-checkers
@itemx -l
List and describe all the available checkers that will be run on packages
diff --git a/guix/scripts/lint.scm b/guix/scripts/lint.scm
index fd9fd7b..31f0e47 100644
--- a/guix/scripts/lint.scm
+++ b/guix/scripts/lint.scm
@@ -36,44 +36,6 @@
\f
;;;
-;;; Command-line options.
-;;;
-
-(define %default-options
- ;; Alist of default option values.
- '())
-
-(define (show-help)
- (display (_ "Usage: guix lint [OPTION]... [PACKAGE]...
-Run a set of checkers on the specified package; if none is specified, run the checkers on all packages.\n"))
- (display (_ "
- -h, --help display this help and exit"))
- (display (_ "
- -l, --list-checkers display the list of available lint checkers"))
- (display (_ "
- -V, --version display version information and exit"))
- (newline)
- (show-bug-report-information))
-
-(define %options
- ;; Specification of the command-line options.
- ;; TODO: add some options:
- ;; * --checkers=checker1,checker2...: only run the specified checkers
- ;; * --certainty=[low,medium,high]: only run checkers that have at least this
- ;; 'certainty'.
- (list (option '(#\h "help") #f #f
- (lambda args
- (show-help)
- (exit 0)))
- (option '(#\l "list-checkers") #f #f
- (lambda args
- (list-checkers-and-exit)))
- (option '(#\V "version") #f #f
- (lambda args
- (show-version-and-exit "guix lint")))))
-
-\f
-;;;
;;; Helpers
;;;
(define* (emit-warning package message #:optional field)
@@ -223,11 +185,70 @@ Run a set of checkers on the specified package; if none is specified, run the ch
(description "Validate package synopsis")
(check check-synopsis-style))))
-(define (run-checkers package)
- ;; Run all the checkers on PACKAGE.
+(define (run-checkers package checkers)
+ ;; Run the given CHECKERS on PACKAGE.
(for-each (lambda (checker)
((lint-checker-check checker) package))
- %checkers))
+ checkers))
+
+\f
+;;;
+;;; Command-line options.
+;;;
+
+(define %default-options
+ ;; Alist of default option values.
+ '())
+
+(define (show-help)
+ (display (_ "Usage: guix lint [OPTION]... [PACKAGE]...
+Run a set of checkers on the specified package; if none is specified, run the checkers on all packages.\n"))
+ (display (_ "
+ -c, --checkers=CHECKER1,CHECKER2...
+ only run the specificed checkers"))
+ (display (_ "
+ -h, --help display this help and exit"))
+ (display (_ "
+ -l, --list-checkers display the list of available lint checkers"))
+ (display (_ "
+ -V, --version display version information and exit"))
+ (newline)
+ (show-bug-report-information))
+
+
+(define %options
+ ;; Specification of the command-line options.
+ ;; TODO: add some options:
+ ;; * --certainty=[low,medium,high]: only run checkers that have at least this
+ ;; 'certainty'.
+ (list (option '(#\c "checkers") #t #f
+ (lambda (opt name arg result arg-handler)
+ (let ((names (string-split arg #\,)))
+ (for-each (lambda (c)
+ (when (not (member c (map lint-checker-name
+ %checkers)))
+ (begin
+ (format (current-error-port)
+ "Invalid checker: ~a~%" c)
+ (exit 1))))
+ names)
+ (values (alist-cons 'checkers
+ (filter (lambda (checker)
+ (member (lint-checker-name checker)
+ names))
+ %checkers)
+ result)
+ #f))))
+ (option '(#\h "help") #f #f
+ (lambda args
+ (show-help)
+ (exit 0)))
+ (option '(#\l "list-checkers") #f #f
+ (lambda args
+ (list-checkers-and-exit)))
+ (option '(#\V "version") #f #f
+ (lambda args
+ (show-version-and-exit "guix lint")))))
\f
;;;
@@ -238,11 +259,11 @@ Run a set of checkers on the specified package; if none is specified, run the ch
(define (parse-options)
;; Return the alist of option values.
(args-fold* args %options
- (lambda (opt name arg result)
+ (lambda (opt name arg result arg-handler)
(leave (_ "~A: unrecognized option~%") name))
- (lambda (arg result)
+ (lambda (arg result arg-handler)
(alist-cons 'argument arg result))
- %default-options))
+ %default-options #f))
(let* ((opts (parse-options))
(args (filter-map (match-lambda
@@ -252,9 +273,10 @@ Run a set of checkers on the specified package; if none is specified, run the ch
(reverse opts))))
- (if (null? args)
- (fold-packages (lambda (p r) (run-checkers p)) '())
- (for-each
- (lambda (spec)
- (run-checkers spec))
- (map specification->package args)))))
+ (let ((checkers (or (assoc-ref opts 'checkers) %checkers)))
+ (if (null? args)
+ (fold-packages (lambda (p r) (run-checkers p checkers)) '())
+ (for-each
+ (lambda (spec)
+ (run-checkers spec checkers))
+ (map specification->package args))))))
diff --git a/tests/guix-lint.sh b/tests/guix-lint.sh
new file mode 100644
index 0000000..3c6f780
--- /dev/null
+++ b/tests/guix-lint.sh
@@ -0,0 +1,70 @@
+# GNU Guix --- Functional package management for GNU
+# Copyright © 2014 Cyril Roelandt <tipecaml@gmail.com>
+#
+# This file is part of GNU Guix.
+#
+# GNU Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GNU Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
+
+#
+# Test the `guix lint' command-line utility.
+#
+
+guix lint --version
+
+module_dir="t-guix-lint-$$"
+mkdir "$module_dir"
+trap "rm -rf $module_dir" EXIT
+
+
+cat > "$module_dir/foo.scm"<<EOF
+(define-module (foo)
+ #:use-module (guix packages)
+ #:use-module (gnu packages base))
+
+(define-public dummy
+ (package (inherit hello)
+ (name "dummy")
+ (version "42")
+ (synopsis "dummy package")
+ (description "dummy package only used for testing purposes.")))
+EOF
+
+export GUIX_PACKAGE_PATH=$module_dir
+
+grep_warning ()
+{
+ res=$(echo "$1" | grep -E -c "(synopsis|description) should")
+ echo $res
+}
+
+# Three issues with the dummy package:
+# 1) the synopsis starts with the package name;
+# 2) the synopsis starts with a lower-case letter;
+# 3) the description starts with a lower-case letter.
+
+if [ $(grep_warning "$(guix lint dummy 2>&1)") -ne 3 ]
+then false; else true; fi
+
+if [ $(grep_warning "$(guix lint -c synopsis dummy 2>&1)") -ne 2 ]
+then false; else true; fi
+
+if [ $(grep_warning "$(guix lint -c description dummy 2>&1)") -ne 1 ]
+then false; else true; fi
+
+if [ $(grep_warning "$(guix lint -c description,synopsis dummy 2>&1)") -ne 3 ]
+then false; else true; fi
+
+if guix lint -c synopsis,invalid-checker dummy 2>&1 | \
+ grep -q 'Invalid checker: invalid-checker'
+then true; else false; fi
--
1.8.4.rc3
^ permalink raw reply related [flat|nested] 4+ messages in thread
* Re: [PATCH] guix lint: add the --checkers option.
2014-10-12 2:19 [PATCH] guix lint: add the --checkers option Cyril Roelandt
@ 2014-10-12 17:02 ` Ludovic Courtès
2014-10-15 0:39 ` [PATCH v2] " Cyril Roelandt
0 siblings, 1 reply; 4+ messages in thread
From: Ludovic Courtès @ 2014-10-12 17:02 UTC (permalink / raw)
To: Cyril Roelandt; +Cc: guix-devel
Cyril Roelandt <tipecaml@gmail.com> skribis:
> * guix/scripts/lint.scm: add the "--checkers" option.
> * doc/guix.texi: Update "Invoking guix lint".
Rather:
* doc/guix.texi (Invoking guix lint): Document it.
> * tests/guix-lint.sh: New file
> * Makefile.am (SCM_TESTS): Add it.
[...]
> +@item --checkers
> +@itemx -c
> +Only enable the checkers specified in a comma-separated list using the
> +names returned by --list-checkers.
Should be @code{--list-checkers}.
> + (begin
> + (format (current-error-port)
> + "Invalid checker: ~a~%" c)
> + (exit 1))))
Use (leave (_ "~a: invalid checker") c) instead.
> + (let ((checkers (or (assoc-ref opts 'checkers) %checkers)))
> + (if (null? args)
> + (fold-packages (lambda (p r) (run-checkers p checkers)) '())
Indent -1.
> + (for-each
> + (lambda (spec)
> + (run-checkers spec checkers))
> + (map specification->package args))))))
Both should be combined, as in:
(for-each (lambda (spec)
(run-checkers (specification->package spec) checkers))
args)
> +grep_warning ()
> +{
> + res=$(echo "$1" | grep -E -c "(synopsis|description) should")
> + echo $res
$(...) is a Bash extension; please use backquotes instead.
> +# Three issues with the dummy package:
> +# 1) the synopsis starts with the package name;
> +# 2) the synopsis starts with a lower-case letter;
> +# 3) the description starts with a lower-case letter.
> +
> +if [ $(grep_warning "$(guix lint dummy 2>&1)") -ne 3 ]
> +then false; else true; fi
> +
> +if [ $(grep_warning "$(guix lint -c synopsis dummy 2>&1)") -ne 2 ]
> +then false; else true; fi
> +
> +if [ $(grep_warning "$(guix lint -c description dummy 2>&1)") -ne 1 ]
> +then false; else true; fi
> +
> +if [ $(grep_warning "$(guix lint -c description,synopsis dummy 2>&1)") -ne 3 ]
> +then false; else true; fi
Backquotes as well (with intermediate variables.)
> +if guix lint -c synopsis,invalid-checker dummy 2>&1 | \
> + grep -q 'Invalid checker: invalid-checker'
> +then true; else false; fi
OK.
Could you send an updated patch?
Thanks,
Ludo’.
^ permalink raw reply [flat|nested] 4+ messages in thread
* [PATCH v2] guix lint: add the --checkers option.
2014-10-12 17:02 ` Ludovic Courtès
@ 2014-10-15 0:39 ` Cyril Roelandt
2014-10-15 17:06 ` Ludovic Courtès
0 siblings, 1 reply; 4+ messages in thread
From: Cyril Roelandt @ 2014-10-15 0:39 UTC (permalink / raw)
To: guix-devel
* guix/scripts/lint.scm: add the "--checkers" option.
* doc/guix.texi (Invoking guix lint): Document it.
* tests/guix-lint.sh: New file
* Makefile.am (SCM_TESTS): Add it.
---
Makefile.am | 3 +-
doc/guix.texi | 5 +++
guix/scripts/lint.scm | 122 ++++++++++++++++++++++++++++----------------------
tests/guix-lint.sh | 74 ++++++++++++++++++++++++++++++
4 files changed, 150 insertions(+), 54 deletions(-)
create mode 100644 tests/guix-lint.sh
diff --git a/Makefile.am b/Makefile.am
index 4b823ec..b13fcbc 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -186,7 +186,8 @@ SH_TESTS = \
tests/guix-package.sh \
tests/guix-system.sh \
tests/guix-archive.sh \
- tests/guix-authenticate.sh
+ tests/guix-authenticate.sh \
+ tests/guix-lint.sh
if BUILD_DAEMON
diff --git a/doc/guix.texi b/doc/guix.texi
index bbe84ab..4c59d9f 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -2855,6 +2855,11 @@ The @var{options} may be zero or more of the following:
@table @code
+@item --checkers
+@itemx -c
+Only enable the checkers specified in a comma-separated list using the
+names returned by @code{--list-checkers}.
+
@item --list-checkers
@itemx -l
List and describe all the available checkers that will be run on packages
diff --git a/guix/scripts/lint.scm b/guix/scripts/lint.scm
index fd9fd7b..5c1ea36 100644
--- a/guix/scripts/lint.scm
+++ b/guix/scripts/lint.scm
@@ -36,44 +36,6 @@
\f
;;;
-;;; Command-line options.
-;;;
-
-(define %default-options
- ;; Alist of default option values.
- '())
-
-(define (show-help)
- (display (_ "Usage: guix lint [OPTION]... [PACKAGE]...
-Run a set of checkers on the specified package; if none is specified, run the checkers on all packages.\n"))
- (display (_ "
- -h, --help display this help and exit"))
- (display (_ "
- -l, --list-checkers display the list of available lint checkers"))
- (display (_ "
- -V, --version display version information and exit"))
- (newline)
- (show-bug-report-information))
-
-(define %options
- ;; Specification of the command-line options.
- ;; TODO: add some options:
- ;; * --checkers=checker1,checker2...: only run the specified checkers
- ;; * --certainty=[low,medium,high]: only run checkers that have at least this
- ;; 'certainty'.
- (list (option '(#\h "help") #f #f
- (lambda args
- (show-help)
- (exit 0)))
- (option '(#\l "list-checkers") #f #f
- (lambda args
- (list-checkers-and-exit)))
- (option '(#\V "version") #f #f
- (lambda args
- (show-version-and-exit "guix lint")))))
-
-\f
-;;;
;;; Helpers
;;;
(define* (emit-warning package message #:optional field)
@@ -223,11 +185,67 @@ Run a set of checkers on the specified package; if none is specified, run the ch
(description "Validate package synopsis")
(check check-synopsis-style))))
-(define (run-checkers package)
- ;; Run all the checkers on PACKAGE.
+(define (run-checkers package checkers)
+ ;; Run the given CHECKERS on PACKAGE.
(for-each (lambda (checker)
((lint-checker-check checker) package))
- %checkers))
+ checkers))
+
+\f
+;;;
+;;; Command-line options.
+;;;
+
+(define %default-options
+ ;; Alist of default option values.
+ '())
+
+(define (show-help)
+ (display (_ "Usage: guix lint [OPTION]... [PACKAGE]...
+Run a set of checkers on the specified package; if none is specified, run the checkers on all packages.\n"))
+ (display (_ "
+ -c, --checkers=CHECKER1,CHECKER2...
+ only run the specificed checkers"))
+ (display (_ "
+ -h, --help display this help and exit"))
+ (display (_ "
+ -l, --list-checkers display the list of available lint checkers"))
+ (display (_ "
+ -V, --version display version information and exit"))
+ (newline)
+ (show-bug-report-information))
+
+
+(define %options
+ ;; Specification of the command-line options.
+ ;; TODO: add some options:
+ ;; * --certainty=[low,medium,high]: only run checkers that have at least this
+ ;; 'certainty'.
+ (list (option '(#\c "checkers") #t #f
+ (lambda (opt name arg result arg-handler)
+ (let ((names (string-split arg #\,)))
+ (for-each (lambda (c)
+ (when (not (member c (map lint-checker-name
+ %checkers)))
+ (leave (_ "~a: invalid checker") c)))
+ names)
+ (values (alist-cons 'checkers
+ (filter (lambda (checker)
+ (member (lint-checker-name checker)
+ names))
+ %checkers)
+ result)
+ #f))))
+ (option '(#\h "help") #f #f
+ (lambda args
+ (show-help)
+ (exit 0)))
+ (option '(#\l "list-checkers") #f #f
+ (lambda args
+ (list-checkers-and-exit)))
+ (option '(#\V "version") #f #f
+ (lambda args
+ (show-version-and-exit "guix lint")))))
\f
;;;
@@ -238,23 +256,21 @@ Run a set of checkers on the specified package; if none is specified, run the ch
(define (parse-options)
;; Return the alist of option values.
(args-fold* args %options
- (lambda (opt name arg result)
+ (lambda (opt name arg result arg-handler)
(leave (_ "~A: unrecognized option~%") name))
- (lambda (arg result)
+ (lambda (arg result arg-handler)
(alist-cons 'argument arg result))
- %default-options))
+ %default-options #f))
(let* ((opts (parse-options))
(args (filter-map (match-lambda
(('argument . value)
value)
(_ #f))
- (reverse opts))))
-
-
- (if (null? args)
- (fold-packages (lambda (p r) (run-checkers p)) '())
- (for-each
- (lambda (spec)
- (run-checkers spec))
- (map specification->package args)))))
+ (reverse opts)))
+ (checkers (or (assoc-ref opts 'checkers) %checkers)))
+ (if (null? args)
+ (fold-packages (lambda (p r) (run-checkers p checkers)) '())
+ (for-each (lambda (spec)
+ (run-checkers (specification->package spec) checkers))
+ args))))
diff --git a/tests/guix-lint.sh b/tests/guix-lint.sh
new file mode 100644
index 0000000..28a096a
--- /dev/null
+++ b/tests/guix-lint.sh
@@ -0,0 +1,74 @@
+# GNU Guix --- Functional package management for GNU
+# Copyright © 2014 Cyril Roelandt <tipecaml@gmail.com>
+#
+# This file is part of GNU Guix.
+#
+# GNU Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GNU Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Guix. If not, see <http://www.gnu.org/licenses/>.
+
+#
+# Test the `guix lint' command-line utility.
+#
+
+guix lint --version
+
+module_dir="t-guix-lint-$$"
+mkdir "$module_dir"
+trap "rm -rf $module_dir" EXIT
+
+
+cat > "$module_dir/foo.scm"<<EOF
+(define-module (foo)
+ #:use-module (guix packages)
+ #:use-module (gnu packages base))
+
+(define-public dummy
+ (package (inherit hello)
+ (name "dummy")
+ (version "42")
+ (synopsis "dummy package")
+ (description "dummy package only used for testing purposes.")))
+EOF
+
+export GUIX_PACKAGE_PATH=$module_dir
+
+grep_warning ()
+{
+ res=`echo "$1" | grep -E -c "(synopsis|description) should"`
+ echo $res
+}
+
+# Three issues with the dummy package:
+# 1) the synopsis starts with the package name;
+# 2) the synopsis starts with a lower-case letter;
+# 3) the description starts with a lower-case letter.
+
+out=`guix lint dummy 2>&1`
+if [ `grep_warning "$out"` -ne 3 ]
+then false; else true; fi
+
+out=`guix lint -c synopsis dummy 2>&1`
+if [ `grep_warning "$out"` -ne 2 ]
+then false; else true; fi
+
+out=`guix lint -c description dummy 2>&1`
+if [ `grep_warning "$out"` -ne 1 ]
+then false; else true; fi
+
+out=`guix lint -c description,synopsis dummy 2>&1`
+if [ `grep_warning "$out"` -ne 3 ]
+then false; else true; fi
+
+if guix lint -c synopsis,invalid-checker dummy 2>&1 | \
+ grep -q 'invalid-checker: invalid checker'
+then true; else false; fi
--
1.8.4.rc3
^ permalink raw reply related [flat|nested] 4+ messages in thread
* Re: [PATCH v2] guix lint: add the --checkers option.
2014-10-15 0:39 ` [PATCH v2] " Cyril Roelandt
@ 2014-10-15 17:06 ` Ludovic Courtès
0 siblings, 0 replies; 4+ messages in thread
From: Ludovic Courtès @ 2014-10-15 17:06 UTC (permalink / raw)
To: Cyril Roelandt; +Cc: guix-devel
Cyril Roelandt <tipecaml@gmail.com> skribis:
> * guix/scripts/lint.scm: add the "--checkers" option.
> * doc/guix.texi (Invoking guix lint): Document it.
> * tests/guix-lint.sh: New file
> * Makefile.am (SCM_TESTS): Add it.
[...]
> +export GUIX_PACKAGE_PATH=$module_dir
I had overlooked this, but it’s also a Bash extension. Use:
GUIX_PACKAGE_PATH="$module_dir"
export GUIX_PACKAGE_PATH
OK to push with this change, thank you!
Ludo’.
^ permalink raw reply [flat|nested] 4+ messages in thread
end of thread, other threads:[~2014-10-15 17:06 UTC | newest]
Thread overview: 4+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2014-10-12 2:19 [PATCH] guix lint: add the --checkers option Cyril Roelandt
2014-10-12 17:02 ` Ludovic Courtès
2014-10-15 0:39 ` [PATCH v2] " Cyril Roelandt
2014-10-15 17:06 ` Ludovic Courtès
Code repositories for project(s) associated with this public inbox
https://git.savannah.gnu.org/cgit/guix.git
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).